package com.zipcodewilmington.singlylinkedlist;

import org.junit.Assert;
import org.junit.Test;

/**
 * Created by leon on 1/10/18.
 */
public class SinglyLinkedListTest {

    @Test
    public void testGetSize(){
        //GIVEN
        SinglyLinkedList list = new SinglyLinkedList();
        int expected = 5;
        //WHEN
        list.addNode(11);
        list.addNode(12);
        list.addNode(13);
        list.addNode(14);
        list.addNode(15);
        int actual = list.getSize();
        //THEN
        Assert.assertEquals(expected, actual);
    }

    @Test
    public void testAddNode(){
        //given
        SinglyLinkedList list = new SinglyLinkedList();
         int expected =1;
         //when
        list.addNode(1);
        int actual=list.getSize();

        //then
        Assert.assertEquals(expected,actual);
    }

    @Test
    public void testRemove(){
        //given
        SinglyLinkedList list = new SinglyLinkedList();
        list.addNode(1);
        list.addNode(2);
        list.addNode(3);
        int expected= 2;
        //when
        list.removeNode(1);
        int actual = list.getSize();

        //then
        Assert.assertEquals(expected,actual);




    }
    @Test
    public void testContain(){
        //give
        SinglyLinkedList list = new SinglyLinkedList();
        list.addNode(1);
        list.addNode(2);
        list.addNode(3);
        boolean expected = true;
        //when
        boolean actual= list.contains(2);
        //then
        Assert.assertEquals(expected,actual);


    }


    @Test
   public void testFind(){
                //GIVEN
        SinglyLinkedList list = new SinglyLinkedList();
        int expected = 2;

                //WHEN
        list.addNode(22);
        list.addNode(12);
        list.addNode(77);list.addNode(14);
        list.addNode(15);
        int actual = list.find(77);
        //THEN
        Assert.assertEquals(expected, actual);
    }

    @Test
    public void testFindFalse(){
        SinglyLinkedList list = new SinglyLinkedList();
        int expected = -1;

        //WHEN
        list.addNode(22);
        list.addNode(12);
        list.addNode(77);
        list.addNode(14);
        list.addNode(15);
        int actual = list.find(7);
        //THEN
        Assert.assertEquals(expected, actual);
    }

      @Test
      public void testGet(){
        //given
          SinglyLinkedList list = new SinglyLinkedList();
          list.addNode(1);
          list.addNode(2);
          list.addNode(8);
          list.addNode(9);
        Integer expected= 9;
        //when
          Integer actual = list.get(0);

        //then
          Assert.assertEquals(expected, actual);

      }

    @Test
    public void testSort() {
        //GIVEN
        SinglyLinkedList list = new SinglyLinkedList();

        list.addNode(1);
        list.addNode(4);
        list.addNode(20);
        list.addNode(15);

        Integer expected = list.get(0);
        //when

        SinglyLinkedList sorted;
        sorted = list.sort(list);
        Integer actual = sorted.get(0);

        //THEN
        Assert.assertEquals(expected, actual);


    }




}
