package com.zipcodewilmington.singlylinkedlist;

/**
 * Created by leon on 1/10/18.
 */
public class SinglyLinkedList {



    class Node{
        Integer data;
        Node nextNode;

         public Node() {
             this.data = 0;
             this.nextNode = null;

         }

         public Node(Integer d, Node n) {
             this.data = d;
             this.nextNode = n;

         }

         public Integer getData() {
             return data;
         }



         public Node getNextNode() {
             return nextNode;
         }

         public void setNextNode(Node nextNode) {
             this.nextNode = nextNode;
         }


    }
    //singlyLinkList fields
    private Node head;
     private Node current;
     public  int size=0;


     public SinglyLinkedList(){
         this.head =null;
         this.current =null;
         this.size=0;
     }

    public int getSize() {
         return size;

    }


    public  void addNode (Integer d){
         Node n= new Node(d, null);
         size++;
         if (head ==null){
             head = n;
             current = head;

         }
         else {
             n.setNextNode(head);
             head =n;
         }


     }

     public void removeNode(int index){
        int counter=0;


            if (size == 0 || index < 0){
                return;

            }else if (size == 1){
                head =null;
                size--;
            }else if (index == size - 1){
                Node currentNode= head;
                while (counter<index){
                    currentNode= currentNode.getNextNode();
                    counter++;
                }
                currentNode.setNextNode(null);
            } else if (index < size){
                Node currentNode= head;

                while (counter<index){
                    currentNode = currentNode.getNextNode();
                    counter++;


                }
                currentNode.setNextNode(currentNode.getNextNode().getNextNode());
                size--;
            }
                return;
            }


 public boolean contains (Integer d){
     boolean value= true;
     current = head;
     for (int i=0; i<size; i++){
         if (current.getData().equals(d)){
             value = true;

             break;
         }
         else {
             current= current.getNextNode();
         }
     }
     return value;

 }

    public int find(Integer d) {
         int value=-1;
         current = head;
        for (int i = 0; i < size; i++) {
            if (current.getData().equals(d)){
                value= i;
                break;
            }
            else current = current.getNextNode();
        }

         return value;
    }



    public Integer get ( int index){
         Integer value= null;
         if (index >= 0 && index< size){
             current= head;
             for (int i = 0; i <size; i++) {
                 if (i==index){
                     value=current.getData();
                     break;
                 }else {
                     current= current.getNextNode();
                 }

             }
         }
return value;
    }



    public SinglyLinkedList copy(SinglyLinkedList listToCopy) {
        SinglyLinkedList copy = new SinglyLinkedList();

        if (listToCopy.head !=null){
            Integer integer = listToCopy.current.getData();
            copy.addNode(integer);

        }
    return copy;
    }


     public SinglyLinkedList sort (SinglyLinkedList listToSort) {
         SinglyLinkedList sortedList;
         Node tempNode= head;
         current=listToSort.head;
         for (int i = 0; i <listToSort.getSize() ; i++) {
             for (int j = 0; j <listToSort.getSize() ; j++) {
                 if(current.getData()> current.getNextNode().getData()){
                     tempNode.setNextNode(current);
                     current =tempNode;
                 }

             }

         }
        sortedList = listToSort;
         return sortedList;
     }










}
